Attribute VB_Name = "WAV32"
Option Explicit

  Declare Sub IntToSingle Lib "wavdat.DLL" (dat As Integer, dat As Single, ByVal num&)
  Declare Function ChrPtr Lib "wavdat.DLL" (dat As Any) As Long

  Global Reply%
  Global WaveIn&
   Global WaveData(131072) As Integer         'ADf[^pzϐ

' general constants
  Global Const MAXPNAMELEN = 32      'max product name length (including NULL)
  Global Const MAXERRORLENGTH = 128  'max error text length (including NULL)

  Type GRIDVIEW
    Width As Integer                 'pointer to locked data buffer
    Height As Integer                'length of data buffer
    VStart As Integer                'used for input only
    HStart As Integer                'for client's use
    VDecade As Integer               'used for input only
    HDecade As Integer               'for client's use
    VLog As Integer                  'used for input only
    HLog As Integer                  'for client's use
    GRDCOL As Long                   'assorted flags (see defines)
  End Type
  
  Type WAVE_NEXT
    lpData As Long                   'pointer to locked data buffer
    dwBufferLength As Long           'length of data buffer
    dwBytesRecorded As Long          'used for input only
    dwUser As Long                   'for client's use
    dwFlags As Long                  'assorted flags (see defines)
    dwLoops As Long                  'loop control counter
    lpWaveNext As Long               'reserved for driver
    reserved As Long                 'reserved for driver
  End Type

'WAVEHDR \
  Type WaveHdr
    lpData As Long                   'pointer to locked data buffer
    dwBufferLength As Long           'length of data buffer
    dwBytesRecorded As Long          'used for input only
    dwUser As Long                   'for client's use
    dwFlags As Long                  'assorted flags (see defines)
    dwLoops As Long                  'loop control counter
    lpNext As WAVE_NEXT              'reserved for driver
    reserved As Long                 'reserved for driver
  End Type
  
'WAVEOUTCAPS \
  Type WaveOutCaps
    wMid As Integer                  'manufacturer ID
    wPid As Integer                  'product ID
    vDriverVersion As Integer        'version of the driver
    szPname As String * MAXPNAMELEN  'product name (NULL terminated string)
    dwFormats As Long                'formats supported
    wChannels As Integer             'number of sources supported
    dwSupport As Long                'functionality supported by driver
  End Type

' flags for dwSupport field of WAVEOUTCAPS
  Global Const WAVECAPS_PITCH = 1        'supports pitch control
  Global Const WAVECAPS_PLAYBACKRATE = 2 'supports playback rate control
  Global Const WAVECAPS_VOLUME = 4       'supports volume control
  Global Const WAVECAPS_LRVOLUME = 8     'separate left-right volume control
  Global Const WAVECAPS_SYNC = &H10

'WAVEINCAPS \
  Type WaveInCaps
    wMid As Integer                  'manufacturer ID
    wPid As Integer                  'product ID
    vDriverVersion As Integer        'version of the driver
    szPname As String * MAXPNAMELEN  'product name (NULL terminated string)
    dwFormats As Long                'formats supported
    wChannels As Integer             'number of channels supported
  End Type

' defines for dwFormat field of WAVEINCAPS and WAVEOUTCAPS
  Global Const WAVE_INVALIDFORMAT = 0    'invalid format
  Global Const WAVE_FORMAT_1M08 = 1      '11.025 kHz, Mono, 8-bit
  Global Const WAVE_FORMAT_1S08 = 2      '11.025 kHz, Stereo, 8-bit
  Global Const WAVE_FORMAT_1M16 = 4      '11.025 kHz, Mono, 16-bit
  Global Const WAVE_FORMAT_1S16 = 8      '11.025 kHz, Stereo, 16-bit
  Global Const WAVE_FORMAT_2M08 = &H10   '22.05 kHz, Mono, 8-bit
  Global Const WAVE_FORMAT_2S08 = &H20   '22.05 kHz, Stereo, 8-bit
  Global Const WAVE_FORMAT_2M16 = &H40   '22.05 kHz, Mono, 16-bit
  Global Const WAVE_FORMAT_2S16 = &H80   '22.05 kHz, Stereo, 16-bit
  Global Const WAVE_FORMAT_4M08 = &H100  '44.1 kHz, Mono, 8-bit
  Global Const WAVE_FORMAT_4S08 = &H200  '44.1 kHz, Stereo, 8-bit
  Global Const WAVE_FORMAT_4M16 = &H400  '44.1 kHz, Mono, 16-bit
  Global Const WAVE_FORMAT_4S16 = &H800  '44.1 kHz, Stereo, 16-bit

' flags for wFormatTag field of WAVEFORMAT
  Global Const WAVE_FORMAT_PCM = 1

'WAVEFORMAT \
  Type WaveFormat
    wFormatTag As Integer      'format type
    nChannels As Integer       'number of channels (i.e. mono, stereo, etc.)
    nSamplesPerSec As Long     'sample rate
    nAvgBytesPerSec As Long    'for buffer estimation
    nBlockAlign As Integer     'block size of data
  End Type
  
  Type WaveFormatEx
    wFormatTag As Integer      'format type
    nChannels As Integer       'number of channels (i.e. mono, stereo, etc.)
    nSamplesPerSec As Long     'sample rate
    nAvgBytesPerSec As Long    'for buffer estimation
    nBlockAlign As Integer     'block size of data
    wBitsPerSample As Integer
    wBitsPerSam As Integer
  End Type

'PCMWAVEFORMAT \
  Type PCMWaveFormat
    wf As WaveFormat
    wBitsPerSample As Integer
  End Type

' MMTIME data structure
  Type MMTIME
    mmt_wType As Long         'indicates the contents of the union
    mmt_union As Long         'ms
  End Type
 
  Type SMPTE
    smpte_hour As String * 1      'hours
    smpte_min As String * 1       'minutes
    smpte_sec As String * 1       'seconds
    smpte_frame As String * 1     'frames
    smpte_fps As String * 1       'frames per second
    smpte_reserved As String * 1  'pad
  End Type
  
'; general MMIO information data structure
  Type MMIOINFO
'        ; general fields
    mmio_dwFlags As Long          'general status flags
    mmio_fccIOProc As Long        'pointer to I/O procedure
    mmio_pIOProc As Long          'pointer to I/O procedure
    mmio_wErrorRet As Integer     'place for error to be returned
    mmio_htask As Integer         'alternate local task

'        ; fields maintained by MMIO functions during buffered I/O
    mmio_cchBuffer As Long        'size of I/O buffer (or 0L)
    mmio_pchBuffer As Long        'start of I/O buffer (or NULL)
    mmio_pchNext As Long          'pointer to next byte to read/write
    mmio_pchEndRead As Long       'pointer to last valid byte to read
    mmio_pchEndWrite As Long      'pointer to last byte to write
    mmio_lBufOffset As Long       'disk offset of start of buffer

'       ; fields maintained by I/O procedure
    mmio_lDiskOffset As Long      'disk offset of next read or write
    mmio_adwInfo As Long          'data specific to type of MMIOPROC
            DUM1      As Long
            DUM2      As Long
'        ; other fields maintained by MMIO
    mmio_dwReserved1 As Long      'reserved for MMIO use
    mmio_dwReserved2 As Long      'reserved for MMIO use
    mmio_hmmio As Integer         'handle to open file
  End Type

'; RIFF chunk information data structure
  Type MMCKINFO
    mmck_ckid As Long             'chunk ID
    mmck_cksize As Long           'chunk size
    mmck_fccType As Long          'form type or list type
    mmck_dwDataOffset As Long     'offset of data portion of chunk
    mmck_dwFlags As Long          'flags used by MMIO functions
  End Type
  
'  Global pcmwf As PCMWaveFormat
  Global pcmwf As WaveFormatEx
  Global WHdrOut As WaveHdr
  Global WHdrIn As WaveHdr
  
  
  Declare Function waveInGetNumDevs Lib "WINMM" () As Long
  Declare Function waveInGetDevCaps Lib "WINMM" (ByVal wDeviceId&, lpCaps As WaveInCaps, ByVal wSize%) As Long
  Declare Function waveOutGetNumDevs Lib "WINMM" () As Long
  Declare Function waveOutGetDevCaps Lib "WINMM" (ByVal wDeviceId%, lpCaps As WaveOutCaps, ByVal wSize%) As Long

  Declare Function waveInOpen Lib "WINMM" (lphWaveIn&, ByVal wDeviceId&, pwfx As WaveFormatEx, ByVal dwCallback&, ByVal dwCallbackInstance&, ByVal dwFlags&) As Long
  Declare Function waveInClose Lib "WINMM" (ByVal hWaveIn&) As Long
  Declare Function waveOutOpen Lib "WINMM" (lphWaveOut&, ByVal wDeviceId&, pwfx As WaveFormatEx, ByVal dwCallback&, ByVal dwCallbackInstance&, ByVal dwFlags&) As Long
  Declare Function waveOutClose Lib "WINMM" (ByVal hWaveOut&) As Long
  Declare Function waveInGetID Lib "WINMM" (ByVal hWaveIn&, lpwDeviceID&) As Long
  Declare Function waveOutGetID Lib "WINMM" (ByVal hWaveOut&, lpwDeviceID&) As Long
  Declare Function waveInGetErrorText Lib "WINMM" (ByVal wError%, ByVal lpText$, ByVal wSize&) As Long
  Declare Function waveOutGetErrorText Lib "WINMM" (ByVal wError%, ByVal lpText$, ByVal wSize&) As Long
  Declare Function waveInGetPosition Lib "WINMM" (ByVal hWaveIn&, lpInfo As MMTIME, ByVal wSize&) As Long
  Declare Function waveOutGetPosition Lib "WINMM" (ByVal hWaveOut&, lpInfo As MMTIME, ByVal wSize&) As Long
  Declare Function waveInMessage Lib "WINMM" (ByVal hWaveIn&, ByVal msg%, ByVal dwParam1&, ByVal dwParam2&) As Long
  Declare Function waveOutMessage Lib "WINMM" (ByVal hWaveOut&, ByVal msg%, ByVal dwParam1&, ByVal dwParam2&) As Long
  
  Declare Function waveOutPrepareHeader Lib "WINMM" (ByVal hWaveOut&, lpWaveOutHdr As WaveHdr, ByVal wSize%) As Long
  Declare Function waveOutWrite Lib "WINMM" (ByVal hWaveOut&, lpWaveOutHdr As WaveHdr, ByVal wSize%) As Long
  Declare Function waveOutUnprepareHeader Lib "WINMM" (ByVal hWaveOut&, lpWaveOutHdr As WaveHdr, ByVal wSize%) As Long
  Declare Function waveOutBreakLoop Lib "WINMM" (ByVal hWaveOut&) As Long
  Declare Function waveOutPause Lib "WINMM" (ByVal hWaveOut&) As Long
  Declare Function waveOutRestart Lib "WINMM" (ByVal hWaveOut&) As Long
  Declare Function waveOutReset Lib "WINMM" (ByVal hWaveOut&) As Long
  Declare Function waveOutGetPitch Lib "WINMM" (ByVal hWaveOut&, lpdwPitch As Long) As Long
                                                                      'LPDWORD
  Declare Function waveOutGetPlaybackRate Lib "WINMM" (ByVal hWaveOut&, lpdwRate As Long) As Long
  Declare Function waveOutSetPitch Lib "WINMM" (ByVal hWaveOut&, ByVal dwPitch As Long) As Long
  Declare Function waveOutSetPlaybackRate Lib "WINMM" (ByVal hWaveOut&, ByVal dwRate As Long) As Long
  Declare Function waveOutGetVolume Lib "WINMM" (ByVal wDeviceId&, lpdwVolume As Long) As Long
  Declare Function waveOutSetVolume Lib "WINMM" (ByVal wDeviceId&, ByVal dwVolume As Long) As Long
  
  Declare Function waveInAddBuffer Lib "WINMM" (ByVal hWaveIn&, lpWaveInHdr As WaveHdr, ByVal wSize%) As Long
  Declare Function waveInPrepareHeader Lib "WINMM" (ByVal hWaveIn&, lpWaveInHdr As WaveHdr, ByVal wSize%) As Long
  Declare Function waveInUnprepareHeader Lib "WINMM" (ByVal hWaveIn&, lpWaveInHdr As WaveHdr, ByVal wSize%) As Long
  Declare Function waveInStart Lib "WINMM" (ByVal hWaveIn&) As Long
  Declare Function waveInStop Lib "WINMM" (ByVal hWaveIn&) As Long
  Declare Function waveInReset Lib "WINMM" (ByVal hWaveIn As Long) As Long


  Declare Function GlobalAlloc Lib "Kernel32" (ByVal fuAlloc&, ByVal cbAlloc&) As Long
  Declare Function GlobalLock Lib "Kernel32" (ByVal hglb&) As Long
  Declare Function GlobalUnLock Lib "Kernel32" (ByVal hglb&) As Long
  Declare Function Globalfree Lib "Kernel32" (ByVal hglb&) As Long
  Declare Function GlobalFlags Lib "Kernel32" (ByVal hglb&) As Long
  Declare Sub hmemcpy Lib "Kernel32" (hpvDest As Any, hpvSource As Any, ByVal num&)

  
  Declare Function mmioClose Lib "WINMM" (ByVal hmmio%, ByVal uFlags%) As Integer
  Declare Function mmioRead Lib "WINMM" (ByVal hmmio%, pch As Any, ByVal cch&) As Long
  Declare Function mmioWrite Lib "WINMM" (ByVal hmmio%, pch As Any, ByVal cch&) As Long
  Declare Function mmioSeek Lib "WINMM" (ByVal hmmio%, ByVal lOffset&, ByVal iOrigin%) As Long
  Declare Function mmioGetInfo Lib "WINMM" (ByVal hmmio%, lpmmioinfo As MMIOINFO, ByVal uFlags%) As Integer
  Declare Function mmioSetInfo Lib "WINMM" (ByVal hmmio%, lpmmioinfo As MMIOINFO, ByVal uFlags%) As Integer
  Declare Function mmioSetBuffer Lib "WINMM" (ByVal hmmio%, ByVal pchBuffer$, ByVal cchBuffer&, ByVal uFlags%) As Integer
  Declare Function mmioFlush Lib "WINMM" (ByVal hmmio%, ByVal uFlags%) As Integer
  Declare Function mmioAdvance Lib "WINMM" (ByVal hmmio%, lpmmioinfo As MMIOINFO, ByVal uFlags%) As Integer
  Declare Function mmioSendMessage Lib "WINMM" (ByVal hmmio%, ByVal uMessage%, ByVal lParam1&, ByVal lParam2&) As Long
  Declare Function mmioDescend Lib "WINMM" (ByVal hmmio%, lpck As MMCKINFO, lpckParent As Any, ByVal uFlags%) As Integer
  Declare Function mmioAscend Lib "WINMM" (ByVal hmmio%, lpck As MMCKINFO, ByVal uFlags%) As Integer
  Declare Function mmioCreateChunk Lib "WINMM" (ByVal hmmio%, lpck As MMCKINFO, ByVal uFlags%) As Integer
  Declare Function mmioStringToFOURCC Lib "WINMM" (ByVal sz$, ByVal uFlags%) As Long
  Declare Function mmioOpen Lib "WINMM" (ByVal szFileName$, lpmmioinfo As Any, ByVal dwOpenFlags&) As Integer
  Declare Function mmioRename Lib "WINMM" (ByVal szFileName$, ByVal szNewFileName$, lpmmioinfo As MMIOINFO, ByVal dwRenameFlags&) As Integer
  
  Global Const GMEM_FIXED = 0
  Global Const GMEM_MOVEABLE = 2
  Global Const GMEM_NOCOMPACT = &H10
  Global Const GMEM_NODISCARD = &H20
  Global Const GMEM_ZEROINIT = &H40
  Global Const GMEM_MODIFY = &H80
  Global Const GMEM_DISCARDABLE = &H100
  Global Const GMEM_NOT_BANKED = &H1000
  Global Const GMEM_DDESHARE = &H2000
  Global Const GMEM_SHARE = &H2000
  Global Const GMEM_NOTIFY = &H4000
  Global Const GMEM_LOWER = GMEM_NOT_BANKED
  Global Const GHND = GMEM_MOVEABLE + GMEM_ZEROINIT
  Global Const GPTR = GMEM_FIXED + GMEM_ZEROINIT

'  Flags returned by GlobalFlags (in addition to GMEM_DISCARDABLE)
  Global Const GMEM_DISCARDED = &H4000
  Global Const GMEM_LOCKCOUNT = &HFF

'; types for wType field in MMTIME struct
  Global Const TIME_MS = &H1               'time in milliseconds
  Global Const TIME_SAMPLES = &H2          'number of wave samples
  Global Const TIME_BYTES = &H4            'current byte offset
  Global Const TIME_SMPTE = &H8            'SMPTE time
  Global Const TIME_MIDI = &H10            'MIDI time


'     String resource number bases (internal use)

  Global Const MMSYSERR_BASE = 0
  Global Const WAVERR_BASE = 32
  Global Const MIDIERR_BASE = 64
  Global Const TIMERR_BASE = 96
  Global Const JOYERR_BASE = 160
  Global Const MCIERR_BASE = 256

  Global Const MCI_STRING_OFFSET = 512
  Global Const MCI_VD_OFFSET = 1024
  Global Const MCI_CD_OFFSET = 1088
  Global Const MCI_WAVE_OFFSET = 1152
  Global Const MCI_SEQ_OFFSET = 1216

'     General error return values

' general error return values
  Global Const MMSYSERR_NOERROR = 0                       'no error
  Global Const MMSYSERR_ERROR = (MMSYSERR_BASE + 1)       'unspecified error
  Global Const MMSYSERR_BADDEVICEID = (MMSYSERR_BASE + 2) 'device ID out of range
  Global Const MMSYSERR_NOTENABLED = MMSYSERR_BASE + 3    'driver failed enable
  Global Const MMSYSERR_ALLOCATED = MMSYSERR_BASE + 4     'device already allocated
  Global Const MMSYSERR_INVALHANDLE = MMSYSERR_BASE + 5   'device handle is invalid
  Global Const MMSYSERR_NODRIVER = MMSYSERR_BASE + 6      'no device driver present
  Global Const MMSYSERR_NOMEM = MMSYSERR_BASE + 7         'memory allocation error
  Global Const MMSYSERR_NOTSUPPORTED = MMSYSERR_BASE + 8  'function isn't supported
  Global Const MMSYSERR_BADERRNUM = MMSYSERR_BASE + 9     'error value out of range
  Global Const MMSYSERR_INVALFLAG = MMSYSERR_BASE + 10    'invalid flags passed
  Global Const MMSYSERR_INVALPARAM = MMSYSERR_BASE + 11   'invalid parameter passed
  Global Const MMSYSERR_LASTERROR = MMSYSERR_BASE + 11    'last error in range


' flags used with waveOutOpen(), waveInOpen(), midiInOpen(), and
' midiOutOpen() to specify the type of the dwCallback parameter.
  Global Const CALLBACK_TYPEMASK = &H70000   'callback type mask
  Global Const CALLBACK_NULL = 0             'no callback
  Global Const CALLBACK_WINDOW = &H10000     'dwCallback is a HWND
  Global Const CALLBACK_TASK = &H20000       'dwCallback is a HTASK
  Global Const CALLBACK_FUNCTION = &H30000   'dwCallback is a FARPROC

'       Manufacturer and product IDs
' Used with wMid and wPid fields in WAVEOUTCAPS, WAVEINCAPS,
' MIDIOUTCAPS, MIDIINCAPS, AUXCAPS, JOYCAPS structures.

'manufacturer IDs
  Global Const MM_MICROSOFT = 1            'Microsoft Corp.
'product IDs
  Global Const MM_MIDI_MAPPER = 1          'MIDI Mapper
  Global Const MM_WAVE_MAPPER = 2          'Wave Mapper
  Global Const MM_SNDBLST_MIDIOUT = 3      'Sound Blaster MIDI output port
  Global Const MM_SNDBLST_MIDIIN = 4       'Sound Blaster MIDI input port
  Global Const MM_SNDBLST_SYNTH = 5        'Sound Blaster internal synthesizer
  Global Const MM_SNDBLST_WAVEOUT = 6      'Sound Blaster waveform output
  Global Const MM_SNDBLST_WAVEIN = 7       'Sound Blaster waveform input
  Global Const MM_ADLIB = 9                'Ad Lib-compatible synthesizer
  Global Const MM_MPU401_MIDIOUT = 10      'MPU401-compatible MIDI output port
  Global Const MM_MPU401_MIDIIN = 11       'MPU401-compatible MIDI input port
  Global Const MM_PC_JOYSTICK = 12         'Joystick adapter

' flag values for wFlags parameter
  Global Const SND_SYNC = 0                'play synchronously (default)
  Global Const SND_ASYNC = 1               'play asynchronously
  Global Const SND_NODEFAULT = 2           'don't use default sound
  Global Const SND_MEMORY = 4              'lpszSoundName points to a memory file
  Global Const SND_LOOP = 8                'loop the sound until next sndPlaySound
  Global Const SND_NOSTOP = &H10           'don't stop any currently playing sound


' waveform audio error return values
  Global Const WAVERR_BADFORMAT = WAVERR_BASE + 0    'unsupported wave format
  Global Const WAVERR_STILLPLAYING = WAVERR_BASE + 1 'still something playing
  Global Const WAVERR_UNPREPARED = WAVERR_BASE + 2   'header not prepared
  Global Const WAVERR_SYNC = WAVERR_BASE + 3         'device is synchronous
  Global Const WAVERR_LASTERROR = WAVERR_BASE + 3    'last error in range

' device ID for wave device mapper
  Global Const Wave_Mapper = -1
' flags for dwFlags parameter in waveOutOpen() and waveInOpen()
  Global Const WAVE_FORMAT_QUERY = 1
  Global Const WAVE_ALLOWSYNC = 2

' flags for dwFlags field of WAVEHDR
  Global Const WHDR_DONE = 1              'done bit
  Global Const WHDR_PREPARED = 2          'set if this header has been prepared
  Global Const WHDR_BEGINLOOP = 4         'loop start block
  Global Const WHDR_ENDLOOP = 8           'loop end block
  Global Const WHDR_INQUEUE = &H10        'reserved for driver

' timer error return values
  Global Const TIMERR_NOERROR = 0               'no error
  Global Const TIMERR_NOCANDO = TIMERR_BASE + 1 'request not completed
  Global Const TIMERR_STRUCT = TIMERR_BASE + 33 'time struct size
' flags for wFlags parameter of timeSetEvent() function
  Global Const TIME_ONESHOT = 0                 'program timer for single event
  Global Const TIME_PERIODIC = 1                'program for continuous periodic event

' MMIO error return values
  Global Const MMIOERR_BASE = 256
  Global Const MMIOERR_FILENOTFOUND = MMIOERR_BASE + 1  'file not found
  Global Const MMIOERR_OUTOFMEMORY = MMIOERR_BASE + 2   'out of memory
  Global Const MMIOERR_CANNOTOPEN = MMIOERR_BASE + 3    'cannot open
  Global Const MMIOERR_CANNOTCLOSE = MMIOERR_BASE + 4   'cannot close
  Global Const MMIOERR_CANNOTREAD = MMIOERR_BASE + 5    'cannot read
  Global Const MMIOERR_CANNOTWRITE = MMIOERR_BASE + 6   'cannot write
  Global Const MMIOERR_CANNOTSEEK = MMIOERR_BASE + 7    'cannot seek
  Global Const MMIOERR_CANNOTEXPAND = MMIOERR_BASE + 8  'cannot expand file
  Global Const MMIOERR_CHUNKNOTFOUND = MMIOERR_BASE + 9 'chunk not found
  Global Const MMIOERR_UNBUFFERED = MMIOERR_BASE + 10   'file is unbuffered
' MMIO constants
  Global Const CFSEPCHAR = "+"            'compound file name separator char.

'; bit field masks
  Global Const MMIO_RWMODE = 3         'open file for reading/writing/both
  Global Const MMIO_SHAREMODE = &H70   'file sharing mode number
'; constants for dwFlags field of MMIOINFO
  Global Const MMIO_CREATE = &H1000    'create new file (or truncate file)
  Global Const MMIO_PARSE = &H100      'parse new file returning path
  Global Const MMIO_DELETE = &H200     'create new file (or truncate file)
  Global Const MMIO_EXIST = &H4000     'checks for existence of file
  Global Const MMIO_ALLOCBUF = &H10000 'mmioOpen() should allocate a buffer
  Global Const MMIO_GETTEMP = &H20000  'mmioOpen() should retrieve temp name
  Global Const MMIO_DIRTY = &H10000000 'I/O buffer is dirty
' read/write mode numbers (bit field MMIO_RWMODE)
  Global Const MMIO_READ = 0           'open file for reading only
  Global Const MMIO_WRITE = 1          'open file for writing only
  Global Const MMIO_READWRITE = 2      'open file for reading and writing
' share mode numbers (bit field MMIO_SHAREMODE)
  Global Const MMIO_COMPAT = 0         'compatibility mode
  Global Const MMIO_EXCLUSIVE = &H10   'exclusive-access mode
  Global Const MMIO_DENYWRITE = &H20   'deny writing to other processes
  Global Const MMIO_DENYREAD = &H30    'deny reading to other processes
  Global Const MMIO_DENYNONE = &H40    'deny nothing to other processes
' various MMIO flags
  Global Const MMIO_FHOPEN = &H10      'mmioClose: keep file handle open
  Global Const MMIO_EMPTYBUF = &H10    'mmioFlush: empty the I/O buffer
  Global Const MMIO_TOUPPER = &H10     'mmioStringToFOURCC: to u-case
  Global Const MMIO_INSTALLPROC = &H10000   'mmioInstallIOProc: install MMIOProc
  Global Const MMIO_GLOBALPROC = &H10000000 'mmioInstallIOProc: install globally
  Global Const MMIO_REMOVEPROC = &H20000    'mmioInstallIOProc: remove MMIOProc
  Global Const MMIO_FINDPROC = &H40000      'mmioInstallIOProc: find an MMIOProc
  Global Const MMIO_FINDCHUNK = &H10   'mmioDescend: find a chunk by ID
  Global Const MMIO_FINDRIFF = &H20    'mmioDescend: find a LIST chunk
  Global Const MMIO_FINDLIST = &H40    'mmioDescend: find a RIFF chunk
  Global Const MMIO_CREATERIFF = &H20  'mmioCreateChunk: make a LIST chunk
  Global Const MMIO_CREATELIST = &H40  'mmioCreateChunk: make a RIFF chunk
' message numbers for MMIOPROC I/O procedure functions
  Global Const MMIOM_READ = MMIO_READ    'read
  Global Const MMIOM_WRITE = MMIO_WRITE  'write
  Global Const MMIOM_SEEK = 2            'seek to a new position in file
  Global Const MMIOM_OPEN = 3            'open file
  Global Const MMIOM_CLOSE = 4           'close file
  Global Const MMIOM_WRITEFLUSH = 5      'write and flush
  Global Const MMIOM_RENAME = 6          'rename specified file
  Global Const MMIOM_USER = &H8000       'beginning of user-defined messages

Function WIOpen(CH, SPS)
  Dim ret

  pcmwf.wFormatTag = WAVE_FORMAT_PCM
  pcmwf.nChannels = CH
  pcmwf.nSamplesPerSec = SPS
  pcmwf.nAvgBytesPerSec = SPS * CH * 2
  pcmwf.nBlockAlign = 2 * CH
  pcmwf.wBitsPerSample = 16
  ret = waveInOpen(WaveIn, Wave_Mapper, pcmwf, 0, ByVal 0&, 0)
  Select Case ret
    Case MMSYSERR_NOERROR
    Case WAVERR_BADFORMAT
      Do
        WAIT 100
        DoEvents
        ret = waveInOpen(WaveIn, Wave_Mapper, pcmwf, 0, ByVal 0&, 0)
      Loop Until ret = MMSYSERR_NOERROR
    Case Else
      Reply = MsgBox("Audio𕜊܂", MB_YESNO)
      Select Case Reply
        Case IDYES
          WaveIn = GetIniProfileInt("WAVE", "hWaveIn", 0)
          ret = waveInClose(WaveIn)
          ret = waveInOpen(WaveIn, Wave_Mapper, pcmwf, 0, ByVal 0&, 0)
        Case IDNO
          Beep
          End
      End Select
  End Select
  Call WriteIniProfile("WAVE", "hWaveIn", Str$(WaveIn))
  WIOpen = ret

End Function



Function WIn(Buffer, LOOPS, SPS, T, CH)
      
  WHdrIn.lpData = Buffer
  WHdrIn.dwFlags = 0
  WHdrIn.dwLoops = LOOPS
  WHdrIn.dwBufferLength = SPS * T * CH * 2
  WHdrIn.dwBytesRecorded = 0
  WIn = waveInPrepareHeader(WaveIn, WHdrIn, 32)
  WIn = waveInAddBuffer(WaveIn, WHdrIn, 32)
End Function

Function Max0(dat, num)
Dim tMax
Dim i

For i = 0 To num - 1
  If tMax < dat(i) Then tMax = dat(i)
Next
Max0 = tMax
End Function

Function Max1(dat, p0, num)
Dim tMax
Dim i

For i = p0 To p0 + num - 1
  If tMax < dat(i) Then tMax = dat(i)
Next
Max1 = tMax
End Function


Function Log10(v)
      
  Log10 = Log(v) / Log(10)
End Function


